
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  LimeGreen
#property indicator_width1   3
#property indicator_level1   0
#property indicator_levelcolor Gold
#property indicator_levelstyle STYLE_DOT




extern string TimeFrame   = "Current time frame";
extern bool   Interpolate = true;








double buf1[];
double buf2[];
double buf3[];



string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;





int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,buf1); SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(1,buf2);
   SetIndexBuffer(2,buf3);
   
   
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
  IndicatorShortName(timeFrameToString(timeFrame) + " Stoch Cycle "); 
  
  return (0);
}



int deinit() { return (0);}


int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { buf1[0] = limit+1; return(0); }
         
         
         
         
   if (calculateValue || timeFrame==Period())
   {
               
         
   for(i=limit; i>=0; i--)
   {
     double stoch1 = iStochastic(NULL,0, 5, 3,3,MODE_LWMA,0,MODE_MAIN,i);
     double stoch2 = iStochastic(NULL,0,14, 3,3,MODE_LWMA,0,MODE_MAIN,i);
     double stoch3 = iStochastic(NULL,0,45,14,3,MODE_LWMA,0,MODE_MAIN,i);
     double stoch4 = iStochastic(NULL,0, 5,20,3,MODE_LWMA,0,MODE_MAIN,i);
       
     buf2[i] = (4.1 * stoch1) + (2.5 *stoch2) + (stoch3) * (stoch4 + 4.0)/11.6;
 }    
    for(i=limit; i>=0; i--) buf3[i] = iMAOnArray(buf2,0,9,0,MODE_LWMA, i);
    for(i=limit; i>=0; i--) buf1[i] = buf2[i] - buf3[i];
      
      
  return(0);
}
     
     
 
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
   int y = iBarShift(NULL,timeFrame,Time[i]);
  
   
   buf1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",0,y);
   buf2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",1,y);
   buf3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",2,y);
   
   
  if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
  if (!Interpolate) continue;
   
   
  
     datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
         for(int k = 1; k < n; k++)
         {
            buf1[i+k] = buf1[i] + (buf1[i+n] - buf1[i])*k/n;
            buf2[i+k] = buf2[i] + (buf2[i+n] - buf2[i])*k/n;
            buf3[i+k] = buf3[i] + (buf3[i+n] - buf3[i])*k/n;
            
            
         }             
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}


string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}



